/* preferences-dialog.c generated by valac 0.56.14, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Color lines for GNOME
 * Copyright © 1999 Free Software Foundation
 * Authors: Robert Szokovacs <szo@szo.hu>
 *          Szabolcs Ban <shooby@gnome.hu>
 *          Karuna Grewal <karunagrewal98@gmail.com>
 *          Ruxandra Simion <ruxandra.simion93@gmail.com>
 * Copyright © 2007 Christian Persch
 *
 * This game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <https://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define FIVE_OR_MORE_APP_KEY_BACKGROUND_COLOR "background-color"
#define FIVE_OR_MORE_APP_KEY_THEME "ball-theme"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	GtkComboBoxText* theme_box;
	GtkColorButton* color_button;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

VALA_EXTERN GType preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
static void preferences_dialog_theme_set_cb (PreferencesDialog* self,
                                      GtkComboBox* _self_);
static void preferences_dialog_color_set_cb (PreferencesDialog* self,
                                      GtkColorButton* _self_);
VALA_EXTERN PreferencesDialog* preferences_dialog_new (GSettings* settings);
VALA_EXTERN PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GSettings* settings);
static void _preferences_dialog_theme_set_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void _preferences_dialog_color_set_cb_gtk_color_button_color_set (GtkColorButton* _sender,
                                                                  gpointer self);
static void preferences_dialog_finalize (GObject * obj);
static GType preferences_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const gchar* THEME_RENDERER_themes[3];

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
preferences_dialog_theme_set_cb (PreferencesDialog* self,
                                 GtkComboBox* _self_)
{
	GtkComboBoxText* combo_box_text = NULL;
	GtkComboBoxText* _tmp0_;
	gchar* theme = NULL;
	GtkComboBoxText* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_self_, gtk_combo_box_text_get_type ()) ? ((GtkComboBoxText*) _self_) : NULL);
	combo_box_text = _tmp0_;
	_tmp1_ = combo_box_text;
	_tmp2_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp1_);
	_tmp3_ = g_strdup (_tmp2_);
	theme = _tmp3_;
	{
		const gchar** t_collection = NULL;
		gint t_collection_length1 = 0;
		gint _t_collection_size_ = 0;
		gint t_it = 0;
		t_collection = THEME_RENDERER_themes;
		t_collection_length1 = G_N_ELEMENTS (THEME_RENDERER_themes);
		for (t_it = 0; t_it < t_collection_length1; t_it = t_it + 1) {
			const gchar* t = NULL;
			t = t_collection[t_it];
			{
				const gchar* _tmp4_;
				gchar** _tmp5_;
				gchar** _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gboolean _tmp10_;
				_tmp4_ = t;
				_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, ".", 0);
				_tmp7_ = _tmp6_;
				_tmp7__length1 = _vala_array_length (_tmp5_);
				_tmp8_ = _tmp7_[0];
				_tmp9_ = theme;
				_tmp10_ = g_strcmp0 (_tmp8_, _tmp9_) == 0;
				_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
				if (_tmp10_) {
					GSettings* _tmp11_;
					const gchar* _tmp12_;
					_tmp11_ = self->priv->settings;
					_tmp12_ = t;
					if (!g_settings_set_string (_tmp11_, "ball-theme", _tmp12_)) {
						const gchar* _tmp13_;
						_tmp13_ = t;
						g_warning ("preferences-dialog.vala:44: Failed to set theme: %s", _tmp13_);
					}
					_g_free0 (theme);
					_g_object_unref0 (combo_box_text);
					return;
				}
			}
		}
	}
	_g_free0 (theme);
	_g_object_unref0 (combo_box_text);
}

static void
preferences_dialog_color_set_cb (PreferencesDialog* self,
                                 GtkColorButton* _self_)
{
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _self_, &_tmp0_);
	color = _tmp0_;
	_tmp1_ = self->priv->settings;
	_tmp2_ = gdk_rgba_to_string (&color);
	_tmp3_ = _tmp2_;
	_tmp4_ = !g_settings_set_string (_tmp1_, FIVE_OR_MORE_APP_KEY_BACKGROUND_COLOR, _tmp3_);
	_g_free0 (_tmp3_);
	if (_tmp4_) {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = gdk_rgba_to_string (&color);
		_tmp6_ = _tmp5_;
		g_warning ("preferences-dialog.vala:55: Failed to set color: %s", _tmp6_);
		_g_free0 (_tmp6_);
	}
}

static void
_preferences_dialog_theme_set_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
	preferences_dialog_theme_set_cb ((PreferencesDialog*) self, _sender);
}

static void
_preferences_dialog_color_set_cb_gtk_color_button_color_set (GtkColorButton* _sender,
                                                             gpointer self)
{
	preferences_dialog_color_set_cb ((PreferencesDialog*) self, _sender);
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GSettings* settings)
{
	PreferencesDialog * self = NULL;
	GSettings* _tmp0_;
	gchar* theme = NULL;
	gchar* _tmp1_;
	GtkComboBoxText* _tmp7_;
	gchar* color_str = NULL;
	gchar* _tmp8_;
	GdkRGBA color = {0};
	GtkColorButton* _tmp9_;
	GdkRGBA _tmp10_;
	GtkColorButton* _tmp11_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (PreferencesDialog*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = g_settings_get_string (settings, FIVE_OR_MORE_APP_KEY_THEME);
	theme = _tmp1_;
	{
		gint id = 0;
		id = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				const gchar* _tmp4_;
				const gchar* _tmp5_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = id;
					id = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(id < G_N_ELEMENTS (THEME_RENDERER_themes))) {
					break;
				}
				_tmp4_ = THEME_RENDERER_themes[id];
				_tmp5_ = theme;
				if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
					GtkComboBoxText* _tmp6_;
					_tmp6_ = self->priv->theme_box;
					gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, id);
				}
			}
		}
	}
	_tmp7_ = self->priv->theme_box;
	g_signal_connect_object ((GtkComboBox*) _tmp7_, "changed", (GCallback) _preferences_dialog_theme_set_cb_gtk_combo_box_changed, self, 0);
	_tmp8_ = g_settings_get_string (settings, FIVE_OR_MORE_APP_KEY_BACKGROUND_COLOR);
	color_str = _tmp8_;
	memset (&color, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&color, color_str);
	_tmp9_ = self->priv->color_button;
	_tmp10_ = color;
	gtk_color_chooser_set_rgba ((GtkColorChooser*) _tmp9_, &_tmp10_);
	_tmp11_ = self->priv->color_button;
	g_signal_connect_object (_tmp11_, "color-set", (GCallback) _preferences_dialog_color_set_cb_gtk_color_button_color_set, self, 0);
	_g_free0 (color_str);
	_g_free0 (theme);
	return self;
}

PreferencesDialog*
preferences_dialog_new (GSettings* settings)
{
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings);
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/five-or-more/ui/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "theme_box", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, theme_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "color_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, color_button));
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
	self->priv = preferences_dialog_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__once)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__once, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

